"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tyranid_1 = require("tyranid");
require("tyranid/builtin/server");
exports.Notification = new tyranid_1.Tyr.Collection({
    id: '_n0',
    name: 'tyrNotification',
    express: {
        rest: true,
    },
    internal: true,
    fields: {
        _id: { is: 'mongoid' },
        to: { link: 'user?' },
        type: { link: 'tyrNotificationType' },
        text: { is: 'string' },
    },
    service: {
        send: {
            params: {
                to: { is: 'mongoid', required: true },
                type: { link: 'tyrNotificationType', required: true },
                message: { is: 'string', defaultValue: '' },
            },
        },
        sendInvalidate: {
            params: {
                to: { is: 'mongoid', required: true },
            },
        },
        sendInfo: {
            params: {
                to: { is: 'mongoid', required: true },
                message: { is: 'string', required: true },
            },
        },
        sendWarning: {
            params: {
                to: { is: 'mongoid', required: true },
                message: { is: 'string', required: true },
            },
        },
        sendSuccess: {
            params: {
                to: { is: 'mongoid', required: true },
                message: { is: 'string', required: true },
            },
        },
        sendError: {
            params: {
                to: { is: 'mongoid', required: true },
                message: { is: 'string', required: true },
            },
        },
    },
});
exports.Notification.service = {
    async send(to, type, text) {
        await exports.Notification.save({ to, type, text });
    },
    async sendInvalidate(to) {
        await exports.Notification.send(to, tyranid_1.Tyr.byName.tyrNotificationType.INVALIDATE._id);
    },
    async sendInfo(to, message) {
        return exports.Notification.send(to, tyranid_1.Tyr.byName.tyrNotificationType.INFO._id, message);
    },
    async sendWarning(to, message) {
        return exports.Notification.send(to, tyranid_1.Tyr.byName.tyrNotificationType.WARNING._id, message);
    },
    async sendSuccess(to, message) {
        return exports.Notification.send(to, tyranid_1.Tyr.byName.tyrNotificationType.SUCCESS._id, message);
    },
    async sendError(to, message) {
        return exports.Notification.send(to, tyranid_1.Tyr.byName.tyrNotificationType.ERROR._id, message);
    },
};
//# sourceMappingURL=notification.model.js.map